summaryrefslogtreecommitdiff
path: root/netifd/files/sbin/ifup
diff options
context:
space:
mode:
authorKarel Kočí <cynerd@email.cz>2020-05-28 11:29:34 +0200
committerKarel Kočí <cynerd@email.cz>2020-05-28 11:29:34 +0200
commitc606e009f2639c6b0518c9ad2bdf2b77c35ca6e5 (patch)
tree23efbf3e0456a78bb4a820037789477b8ab8881d /netifd/files/sbin/ifup
parent68bf801ffbda2868703db98cfb2625232da9535c (diff)
downloadopenwrt-personal-pkgs-c606e009f2639c6b0518c9ad2bdf2b77c35ca6e5.tar.gz
openwrt-personal-pkgs-c606e009f2639c6b0518c9ad2bdf2b77c35ca6e5.tar.bz2
openwrt-personal-pkgs-c606e009f2639c6b0518c9ad2bdf2b77c35ca6e5.zip
Add netifd with patch to fix service restart
Diffstat (limited to 'netifd/files/sbin/ifup')
-rwxr-xr-xnetifd/files/sbin/ifup77
1 files changed, 77 insertions, 0 deletions
diff --git a/netifd/files/sbin/ifup b/netifd/files/sbin/ifup
new file mode 100755
index 0000000..5515b91
--- /dev/null
+++ b/netifd/files/sbin/ifup
@@ -0,0 +1,77 @@
+#!/bin/sh
+
+ifup_all=
+setup_wifi=
+
+if_call() {
+ local interface="$1"
+ for mode in $modes; do
+ ubus call network.interface $mode "{ \"interface\" : \"$interface\" }"
+ done
+}
+
+case "$0" in
+ *ifdown) modes=down;;
+ *ifup)
+ modes="down up"
+ setup_wifi=1
+ ;;
+ *) echo "Invalid command: $0";;
+esac
+
+while :; do
+ case "$1" in
+ -a)
+ ifup_all=1
+ shift
+ ;;
+ -w)
+ setup_wifi=
+ shift
+ ;;
+ *)
+ break
+ ;;
+ esac
+done
+
+[ "$modes" = "down up" ] && ubus call network reload
+if [ -n "$ifup_all" ]; then
+ for interface in `ubus -S list 'network.interface.*'`; do
+ if_call "${interface##network.interface.}"
+ done
+ [ -n "$setup_wifi" ] && /sbin/wifi up
+ exit
+else
+ ubus -S list "network.interface.$1" > /dev/null || {
+ echo "Interface $1 not found"
+ exit
+ }
+ if_call "$1"
+fi
+
+if [ -n "$setup_wifi" ] && grep -sq config /etc/config/wireless; then
+ . /lib/functions.sh
+
+ find_related_radios() {
+ local wdev wnet
+ config_get wdev "$1" device
+ config_get wnet "$1" network
+
+ if [ -n "$wdev" ]; then
+ for wnet in $wnet; do
+ if [ "$wnet" = "$network" ]; then
+ append radio_devs "$wdev" "$N"
+ fi
+ done
+ fi
+ }
+
+ network="$1"
+ config_load wireless
+ config_foreach find_related_radios wifi-iface
+
+ for dev in $(echo "$radio_devs" | sort -u); do
+ /sbin/wifi up "$dev"
+ done
+fi